import type { FC } from 'react';
import type { ComponentWithConditionPropsWithFunctionChildren } from './types';
/** A shorthand for
 *
 * ```jsx
 * <If condition={...}>
 *     <Then>
 *         { ... }
 *     </Then>
 * </If>
 * ```
 *
 * The same rules apply to the child elements as with using the `<Then /`> block.
 *
 * @param __namedParameters The props to pass down to the `<IF />` component, see {@link ComponentWithConditionProps}
 */
export declare const When: FC<ComponentWithConditionPropsWithFunctionChildren>;
//# sourceMappingURL=When.d.ts.map